Deleted Added
full compact
36c36
< # $FreeBSD: head/release/release.sh 282500 2015-05-05 16:28:04Z gjb $
---
> # $FreeBSD: head/release/release.sh 282693 2015-05-09 21:08:12Z gjb $
39,40c39
< PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin"
< export PATH
---
> export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin"
41a41,42
> VERSION=2
>
47,49c48,51
< # The directory within which the release will be built.
< CHROOTDIR="/scratch"
< RELENGDIR="$(realpath $(dirname $(basename ${0})))"
---
> usage() {
> echo "Usage: $0 [-c release.conf]"
> exit 1
> }
51,52c53,59
< # The default version control system command to obtain the sources.
< VCSCMD="svn checkout"
---
> # env_setup(): Set up the default build environment variables, such as the
> # CHROOTDIR, VCSCMD, SVNROOT, etc. This is called before the release.conf
> # file is sourced, if '-c <release.conf>' is specified.
> env_setup() {
> # The directory within which the release will be built.
> CHROOTDIR="/scratch"
> RELENGDIR="$(dirname $(realpath ${0}))"
54,59c61,68
< # The default svn checkout server, and svn branches for src/, doc/,
< # and ports/.
< SVNROOT="svn://svn.FreeBSD.org/"
< SRCBRANCH="base/head@rHEAD"
< DOCBRANCH="doc/head@rHEAD"
< PORTBRANCH="ports/head@rHEAD"
---
> # The default version control system command to obtain the sources.
> for _dir in /usr/bin /usr/local/bin; do
> for _svn in svn svnlite; do
> [ -x "${_dir}/${_svn}" ] && VCSCMD="${_dir}/${_svn}"
> [ ! -z "${VCSCMD}" ] && break 2
> done
> done
> VCSCMD="${VCSCMD} checkout"
61,62c70,75
< # Set for embedded device builds.
< EMBEDDEDBUILD=
---
> # The default svn checkout server, and svn branches for src/, doc/,
> # and ports/.
> SVNROOT="svn://svn.FreeBSD.org/"
> SRCBRANCH="base/head@rHEAD"
> DOCBRANCH="doc/head@rHEAD"
> PORTBRANCH="ports/head@rHEAD"
64,66c77,78
< # Sometimes one needs to checkout src with --force svn option.
< # If custom kernel configs copied to src tree before checkout, e.g.
< SRC_FORCE_CHECKOUT=
---
> # Set for embedded device builds.
> EMBEDDEDBUILD=
68,72c80,82
< # The default make.conf and src.conf to use. Set to /dev/null
< # by default to avoid polluting the chroot(8) environment with
< # non-default settings.
< MAKE_CONF="/dev/null"
< SRC_CONF="/dev/null"
---
> # Sometimes one needs to checkout src with --force svn option.
> # If custom kernel configs copied to src tree before checkout, e.g.
> SRC_FORCE_CHECKOUT=
74,77c84,88
< # The number of make(1) jobs, defaults to the number of CPUs available for
< # buildworld, and half of number of CPUs available for buildkernel.
< WORLD_FLAGS="-j$(sysctl -n hw.ncpu)"
< KERNEL_FLAGS="-j$(( $(( $(sysctl -n hw.ncpu) + 1 )) / 2))"
---
> # The default make.conf and src.conf to use. Set to /dev/null
> # by default to avoid polluting the chroot(8) environment with
> # non-default settings.
> MAKE_CONF="/dev/null"
> SRC_CONF="/dev/null"
79c90,93
< MAKE_FLAGS="-s"
---
> # The number of make(1) jobs, defaults to the number of CPUs available
> # for buildworld, and half of number of CPUs available for buildkernel.
> WORLD_FLAGS="-j$(sysctl -n hw.ncpu)"
> KERNEL_FLAGS="-j$(( $(( $(sysctl -n hw.ncpu) + 1 )) / 2))"
81,82c95
< # The name of the kernel to build, defaults to GENERIC.
< KERNEL="GENERIC"
---
> MAKE_FLAGS="-s"
84,87c97,98
< # Set to non-empty value to disable checkout of doc/ and/or ports/. Disabling
< # ports/ checkout also forces NODOC to be set.
< NODOC=
< NOPORTS=
---
> # The name of the kernel to build, defaults to GENERIC.
> KERNEL="GENERIC"
89,91c100,103
< # Set to non-empty value to build dvd1.iso as part of the release.
< WITH_DVD=
< WITH_COMPRESSED_IMAGES=
---
> # Set to non-empty value to disable checkout of doc/ and/or ports/.
> # Disabling ports/ checkout also forces NODOC to be set.
> NODOC=
> NOPORTS=
93,97c105,107
< # Set to non-empty value to build virtual machine images as part of
< # the release.
< WITH_VMIMAGES=
< WITH_COMPRESSED_VMIMAGES=
< XZ_THREADS=0
---
> # Set to non-empty value to build dvd1.iso as part of the release.
> WITH_DVD=
> WITH_COMPRESSED_IMAGES=
99,101c109,113
< # Set to non-empty value to build virtual machine images for various
< # cloud providers as part of the release.
< WITH_CLOUDWARE=
---
> # Set to non-empty value to build virtual machine images as part of
> # the release.
> WITH_VMIMAGES=
> WITH_COMPRESSED_VMIMAGES=
> XZ_THREADS=0
103,106c115,117
< usage() {
< echo "Usage: $0 [-c release.conf]"
< exit 1
< }
---
> # Set to non-empty value to build virtual machine images for various
> # cloud providers as part of the release.
> WITH_CLOUDWARE=
108,121c119,135
< while getopts c: opt; do
< case ${opt} in
< c)
< RELEASECONF="${OPTARG}"
< if [ ! -e "${RELEASECONF}" ]; then
< echo "ERROR: Configuration file ${RELEASECONF} does not exist."
< exit 1
< fi
< # Source the specified configuration file for overrides
< . ${RELEASECONF}
< ;;
< \?)
< usage
< ;;
---
> return 0
> } # env_setup()
>
> # env_check(): Perform sanity tests on the build environment, such as ensuring
> # files/directories exist, as well as adding backwards-compatibility hacks if
> # necessary. This is called unconditionally, and overrides the defaults set
> # in env_setup() if '-c <release.conf>' is specified.
> env_check() {
> chroot_build_release_cmd="chroot_build_release"
> # Fix for backwards-compatibility with release.conf that does not have
> # the trailing '/'.
> case ${SVNROOT} in
> *svn*)
> SVNROOT="${SVNROOT}/"
> ;;
> *)
> ;;
123,124d136
< done
< shift $(($OPTIND - 1))
126,134c138,141
< # Fix for backwards-compatibility with release.conf that does not have the
< # trailing '/'.
< case ${SVNROOT} in
< *svn*)
< SVNROOT="${SVNROOT}/"
< ;;
< *)
< ;;
< esac
---
> # Prefix the branches with the SVNROOT for the full checkout URL.
> SRCBRANCH="${SVNROOT}${SRCBRANCH}"
> DOCBRANCH="${SVNROOT}${DOCBRANCH}"
> PORTBRANCH="${SVNROOT}${PORTBRANCH}"
136,139c143,153
< # Prefix the branches with the SVNROOT for the full checkout URL.
< SRCBRANCH="${SVNROOT}${SRCBRANCH}"
< DOCBRANCH="${SVNROOT}${DOCBRANCH}"
< PORTBRANCH="${SVNROOT}${PORTBRANCH}"
---
> if [ -n "${EMBEDDEDBUILD}" ]; then
> WITH_DVD=
> WITH_COMPRESSED_IMAGES=
> NODOC=yes
> case ${EMBEDDED_TARGET}:${EMBEDDED_TARGET_ARCH} in
> arm:armv6)
> chroot_build_release_cmd="chroot_arm_armv6_build_release"
> ;;
> *)
> esac
> fi
141,145c155,161
< if [ -n "${EMBEDDEDBUILD}" ]; then
< WITH_DVD=
< WITH_COMPRESSED_IMAGES=
< NODOC=yes
< fi
---
> # If PORTS is set and NODOC is unset, force NODOC=yes because the ports
> # tree is required to build the documentation set.
> if [ -n "${NOPORTS}" ] && [ -z "${NODOC}" ]; then
> echo "*** NOTICE: Setting NODOC=1 since ports tree is required"
> echo " and NOPORTS is set."
> NODOC=yes
> fi
147,153c163,172
< # If PORTS is set and NODOC is unset, force NODOC=yes because the ports tree
< # is required to build the documentation set.
< if [ -n "${NOPORTS}" ] && [ -z "${NODOC}" ]; then
< echo "*** NOTICE: Setting NODOC=1 since ports tree is required"
< echo " and NOPORTS is set."
< NODOC=yes
< fi
---
> # If NOPORTS and/or NODOC are unset, they must not pass to make as
> # variables. The release makefile verifies definedness of the
> # NOPORTS/NODOC variables instead of their values.
> DOCPORTS=
> if [ -n "${NOPORTS}" ]; then
> DOCPORTS="NOPORTS=yes "
> fi
> if [ -n "${NODOC}" ]; then
> DOCPORTS="${DOCPORTS}NODOC=yes"
> fi
155,164c174,187
< # If NOPORTS and/or NODOC are unset, they must not pass to make as variables.
< # The release makefile verifies definedness of NOPORTS/NODOC variables
< # instead of their values.
< DOCPORTS=
< if [ -n "${NOPORTS}" ]; then
< DOCPORTS="NOPORTS=yes "
< fi
< if [ -n "${NODOC}" ]; then
< DOCPORTS="${DOCPORTS}NODOC=yes"
< fi
---
> # The aggregated build-time flags based upon variables defined within
> # this file, unless overridden by release.conf. In most cases, these
> # will not need to be changed.
> CONF_FILES="__MAKE_CONF=${MAKE_CONF} SRCCONF=${SRC_CONF}"
> if [ -n "${TARGET}" ] && [ -n "${TARGET_ARCH}" ]; then
> ARCH_FLAGS="TARGET=${TARGET} TARGET_ARCH=${TARGET_ARCH}"
> else
> ARCH_FLAGS=
> fi
> # Force src checkout if configured
> FORCE_SRC_KEY=
> if [ -n "${SRC_FORCE_CHECKOUT}" ]; then
> FORCE_SRC_KEY="--force"
> fi
166,184c189,192
< # The aggregated build-time flags based upon variables defined within
< # this file, unless overridden by release.conf. In most cases, these
< # will not need to be changed.
< CONF_FILES="__MAKE_CONF=${MAKE_CONF} SRCCONF=${SRC_CONF}"
< if [ -n "${TARGET}" ] && [ -n "${TARGET_ARCH}" ]; then
< ARCH_FLAGS="TARGET=${TARGET} TARGET_ARCH=${TARGET_ARCH}"
< else
< ARCH_FLAGS=
< fi
< load_chroot_env
< CHROOT_MAKEENV="${CHROOT_MAKEENV} MAKEOBJDIRPREFIX=${CHROOTDIR}/tmp/obj"
< CHROOT_WMAKEFLAGS="${MAKE_FLAGS} ${WORLD_FLAGS} ${CONF_FILES}"
< CHROOT_IMAKEFLAGS="${CONF_FILES}"
< CHROOT_DMAKEFLAGS="${CONF_FILES}"
< RELEASE_WMAKEFLAGS="${MAKE_FLAGS} ${WORLD_FLAGS} ${ARCH_FLAGS} ${CONF_FILES}"
< RELEASE_KMAKEFLAGS="${MAKE_FLAGS} ${KERNEL_FLAGS} KERNCONF=\"${KERNEL}\" ${ARCH_FLAGS} ${CONF_FILES}"
< RELEASE_RMAKEFLAGS="${ARCH_FLAGS} KERNCONF=\"${KERNEL}\" ${CONF_FILES} \
< ${DOCPORTS} WITH_DVD=${WITH_DVD} WITH_VMIMAGES=${WITH_VMIMAGES} \
< WITH_CLOUDWARE=${WITH_CLOUDWARE} XZ_THREADS=${XZ_THREADS}"
---
> if [ -z "${CHROOTDIR}" ]; then
> echo "Please set CHROOTDIR."
> exit 1
> fi
186,190c194,197
< # Force src checkout if configured
< FORCE_SRC_KEY=
< if [ -n "${SRC_FORCE_CHECKOUT}" ]; then
< FORCE_SRC_KEY="--force"
< fi
---
> if [ $(id -u) -ne 0 ]; then
> echo "Needs to be run as root."
> exit 1
> fi
192,195c199,211
< if [ -z "${CHROOTDIR}" ]; then
< echo "Please set CHROOTDIR."
< exit 1
< fi
---
> CHROOT_MAKEENV="${CHROOT_MAKEENV} \
> MAKEOBJDIRPREFIX=${CHROOTDIR}/tmp/obj"
> CHROOT_WMAKEFLAGS="${MAKE_FLAGS} ${WORLD_FLAGS} ${CONF_FILES}"
> CHROOT_IMAKEFLAGS="${CONF_FILES}"
> CHROOT_DMAKEFLAGS="${CONF_FILES}"
> RELEASE_WMAKEFLAGS="${MAKE_FLAGS} ${WORLD_FLAGS} ${ARCH_FLAGS} \
> ${CONF_FILES}"
> RELEASE_KMAKEFLAGS="${MAKE_FLAGS} ${KERNEL_FLAGS} \
> KERNCONF=\"${KERNEL}\" ${ARCH_FLAGS} ${CONF_FILES}"
> RELEASE_RMAKEFLAGS="${ARCH_FLAGS} \
> KERNCONF=\"${KERNEL}\" ${CONF_FILES} ${DOCPORTS} \
> WITH_DVD=${WITH_DVD} WITH_VMIMAGES=${WITH_VMIMAGES} \
> WITH_CLOUDWARE=${WITH_CLOUDWARE} XZ_THREADS=${XZ_THREADS}"
197,200c213,214
< if [ $(id -u) -ne 0 ]; then
< echo "Needs to be run as root."
< exit 1
< fi
---
> return 0
> } # env_check()
202c216,219
< set -e # Everything must succeed
---
> # chroot_setup(): Prepare the build chroot environment for the release build.
> chroot_setup() {
> load_chroot_env
> mkdir -p ${CHROOTDIR}/usr
204c221,229
< mkdir -p ${CHROOTDIR}/usr
---
> if [ -z "${SRC_UPDATE_SKIP}" ]; then
> ${VCSCMD} ${FORCE_SRC_KEY} ${SRCBRANCH} ${CHROOTDIR}/usr/src
> fi
> if [ -z "${NODOC}" ] && [ -z "${DOC_UPDATE_SKIP}" ]; then
> ${VCSCMD} ${DOCBRANCH} ${CHROOTDIR}/usr/doc
> fi
> if [ -z "${NOPORTS}" ] && [ -z "${PORTS_UPDATE_SKIP}" ]; then
> ${VCSCMD} ${PORTBRANCH} ${CHROOTDIR}/usr/ports
> fi
206,214c231,238
< if [ -z "${SRC_UPDATE_SKIP}" ]; then
< ${VCSCMD} ${FORCE_SRC_KEY} ${SRCBRANCH} ${CHROOTDIR}/usr/src
< fi
< if [ -z "${NODOC}" ] && [ -z "${DOC_UPDATE_SKIP}" ]; then
< ${VCSCMD} ${DOCBRANCH} ${CHROOTDIR}/usr/doc
< fi
< if [ -z "${NOPORTS}" ] && [ -z "${PORTS_UPDATE_SKIP}" ]; then
< ${VCSCMD} ${PORTBRANCH} ${CHROOTDIR}/usr/ports
< fi
---
> if [ -z "${CHROOTBUILD_SKIP}" ]; then
> cd ${CHROOTDIR}/usr/src
> env ${CHROOT_MAKEENV} make ${CHROOT_WMAKEFLAGS} buildworld
> env ${CHROOT_MAKEENV} make ${CHROOT_IMAKEFLAGS} installworld \
> DESTDIR=${CHROOTDIR}
> env ${CHROOT_MAKEENV} make ${CHROOT_DMAKEFLAGS} distribution \
> DESTDIR=${CHROOTDIR}
> fi
216,226c240,241
< if [ -z "${CHROOTBUILD_SKIP}" ]; then
< cd ${CHROOTDIR}/usr/src
< env ${CHROOT_MAKEENV} make ${CHROOT_WMAKEFLAGS} buildworld
< env ${CHROOT_MAKEENV} make ${CHROOT_IMAKEFLAGS} installworld \
< DESTDIR=${CHROOTDIR}
< env ${CHROOT_MAKEENV} make ${CHROOT_DMAKEFLAGS} distribution \
< DESTDIR=${CHROOTDIR}
< fi
< mount -t devfs devfs ${CHROOTDIR}/dev
< cp /etc/resolv.conf ${CHROOTDIR}/etc/resolv.conf
< trap "umount ${CHROOTDIR}/dev" EXIT # Clean up devfs mount on exit
---
> return 0
> } # chroot_setup()
228,237c243,252
< # If MAKE_CONF and/or SRC_CONF are set and not character devices (/dev/null),
< # copy them to the chroot.
< if [ -e ${MAKE_CONF} ] && [ ! -c ${MAKE_CONF} ]; then
< mkdir -p ${CHROOTDIR}/$(dirname ${MAKE_CONF})
< cp ${MAKE_CONF} ${CHROOTDIR}/${MAKE_CONF}
< fi
< if [ -e ${SRC_CONF} ] && [ ! -c ${SRC_CONF} ]; then
< mkdir -p ${CHROOTDIR}/$(dirname ${SRC_CONF})
< cp ${SRC_CONF} ${CHROOTDIR}/${SRC_CONF}
< fi
---
> # extra_chroot_setup(): Prepare anything additional within the build
> # necessary for the release build.
> extra_chroot_setup() {
> mkdir -p ${CHROOTDIR}/dev
> mount -t devfs devfs ${CHROOTDIR}/dev
> [ -e /etc/resolv.conf ] && cp /etc/resolv.conf \
> ${CHROOTDIR}/etc/resolv.conf
> # Run ldconfig(8) in the chroot directory so /var/run/ld-elf*.so.hints
> # is created. This is needed by ports-mgmt/pkg.
> eval chroot ${CHROOTDIR} /etc/rc.d/ldconfig forcerestart
239,240c254,288
< # Embedded builds do not use the 'make release' target.
< if [ -n "${EMBEDDEDBUILD}" ]; then
---
> # If MAKE_CONF and/or SRC_CONF are set and not character devices
> # (/dev/null), copy them to the chroot.
> if [ -e ${MAKE_CONF} ] && [ ! -c ${MAKE_CONF} ]; then
> mkdir -p ${CHROOTDIR}/$(dirname ${MAKE_CONF})
> cp ${MAKE_CONF} ${CHROOTDIR}/${MAKE_CONF}
> fi
> if [ -e ${SRC_CONF} ] && [ ! -c ${SRC_CONF} ]; then
> mkdir -p ${CHROOTDIR}/$(dirname ${SRC_CONF})
> cp ${SRC_CONF} ${CHROOTDIR}/${SRC_CONF}
> fi
>
> if [ -d ${CHROOTDIR}/usr/ports ]; then
> # Trick the ports 'run-autotools-fixup' target to do the right
> # thing.
> _OSVERSION=$(chroot ${CHROOTDIR} /usr/bin/uname -U)
> REVISION=$(chroot ${CHROOTDIR} make -C /usr/src/release -V REVISION)
> BRANCH=$(chroot ${CHROOTDIR} make -C /usr/src/release -V BRANCH)
> UNAME_r=${REVISION}-${BRANCH}
> if [ -d ${CHROOTDIR}/usr/doc ] && [ -z "${NODOC}" ]; then
> PBUILD_FLAGS="OSVERSION=${_OSVERSION} BATCH=yes"
> PBUILD_FLAGS="${PBUILD_FLAGS} UNAME_r=${UNAME_r}"
> PBUILD_FLAGS="${PBUILD_FLAGS} OSREL=${REVISION}"
> chroot ${CHROOTDIR} make -C /usr/ports/textproc/docproj \
> ${PBUILD_FLAGS} OPTIONS_UNSET="FOP IGOR" \
> install clean distclean
> fi
> fi
>
> if [ ! -z "${EMBEDDEDPORTS}" ]; then
> for _PORT in ${EMBEDDEDPORTS}; do
> eval chroot ${CHROOTDIR} make -C /usr/ports/${_PORT} \
> BATCH=1 FORCE_PKG_REGISTER=1 install clean distclean
> done
> fi
>
242,245c290,295
< # If a crochet configuration file exists in *this* checkout of
< # release/, copy it to the /tmp/external directory within the chroot.
< # This allows building embedded releases without relying on updated
< # scripts and/or configurations to exist in the branch being built.
---
>
> return 0
> } # extra_chroot_setup()
>
> # chroot_build_target(): Build the userland and kernel for the build target.
> chroot_build_target() {
247,252c297,303
< if [ -e ${RELENGDIR}/tools/${XDEV}/crochet-${KERNEL}.conf ] && \
< [ -e ${RELENGDIR}/${XDEV}/release.sh ]; then
< mkdir -p ${CHROOTDIR}/tmp/external/${XDEV}/
< cp ${RELENGDIR}/tools/${XDEV}/crochet-${KERNEL}.conf \
< ${CHROOTDIR}/tmp/external/${XDEV}/crochet-${KERNEL}.conf
< /bin/sh ${RELENGDIR}/${XDEV}/release.sh
---
> if [ ! -z "${EMBEDDEDBUILD}" ]; then
> RELEASE_WMAKEFLAGS="${RELEASE_WMAKEFLAGS} \
> TARGET=${EMBEDDED_TARGET} \
> TARGET_ARCH=${EMBEDDED_TARGET_ARCH}"
> RELEASE_KMAKEFLAGS="${RELEASE_KMAKEFLAGS} \
> TARGET=${EMBEDDED_TARGET} \
> TARGET_ARCH=${EMBEDDED_TARGET_ARCH}"
254,262c305,306
< # If the script does not exist for this architecture, exit.
< # This probably should be checked earlier, but allowing the rest
< # of the build process to get this far will at least set up the
< # chroot environment for testing.
< exit 0
< else
< # Not embedded.
< continue
< fi
---
> eval chroot ${CHROOTDIR} make -C /usr/src ${RELEASE_WMAKEFLAGS} buildworld
> eval chroot ${CHROOTDIR} make -C /usr/src ${RELEASE_KMAKEFLAGS} buildkernel
264,267c308,309
< if [ -d ${CHROOTDIR}/usr/ports ]; then
< # Run ldconfig(8) in the chroot directory so /var/run/ld-elf*.so.hints
< # is created. This is needed by ports-mgmt/pkg.
< chroot ${CHROOTDIR} /etc/rc.d/ldconfig forcerestart
---
> return 0
> } # chroot_build_target
269,280c311,329
< ## Trick the ports 'run-autotools-fixup' target to do the right thing.
< _OSVERSION=$(sysctl -n kern.osreldate)
< REVISION=$(chroot ${CHROOTDIR} make -C /usr/src/release -V REVISION)
< BRANCH=$(chroot ${CHROOTDIR} make -C /usr/src/release -V BRANCH)
< UNAME_r=${REVISION}-${BRANCH}
< if [ -d ${CHROOTDIR}/usr/doc ] && [ -z "${NODOC}" ]; then
< PBUILD_FLAGS="OSVERSION=${_OSVERSION} BATCH=yes"
< PBUILD_FLAGS="${PBUILD_FLAGS} UNAME_r=${UNAME_r}"
< PBUILD_FLAGS="${PBUILD_FLAGS} OSREL=${REVISION}"
< chroot ${CHROOTDIR} make -C /usr/ports/textproc/docproj \
< ${PBUILD_FLAGS} OPTIONS_UNSET="FOP IGOR" \
< install clean distclean
---
> # chroot_build_release(): Invoke the 'make release' target.
> chroot_build_release() {
> load_target_env
> eval chroot ${CHROOTDIR} make -C /usr/src/release \
> ${RELEASE_RMAKEFLAGS} release
> eval chroot ${CHROOTDIR} make -C /usr/src/release \
> ${RELEASE_RMAKEFLAGS} install DESTDIR=/R \
> WITH_COMPRESSED_IMAGES=${WITH_COMPRESSED_IMAGES} \
> WITH_COMPRESSED_VMIMAGES=${WITH_COMPRESSED_VMIMAGES}
>
> return 0
> } # chroot_build_release()
>
> # chroot_arm_armv6_build_release(): Create arm/armv6 SD card image.
> chroot_arm_armv6_build_release() {
> load_target_env
> eval chroot ${CHROOTDIR} make -C /usr/src/release obj
> if [ -e "${RELENGDIR}/tools/${EMBEDDED_TARGET}.subr" ]; then
> . "${RELENGDIR}/tools/${EMBEDDED_TARGET}.subr"
282c331,356
< fi
---
> [ ! -z "${RELEASECONF}" ] && . "${RELEASECONF}"
> WORLDDIR="$(eval chroot ${CHROOTDIR} make -C /usr/src/release -V WORLDDIR)"
> OBJDIR="$(eval chroot ${CHROOTDIR} make -C /usr/src/release -V .OBJDIR)"
> DESTDIR="${OBJDIR}/${KERNEL}"
> IMGBASE="${CHROOTDIR}/${OBJDIR}/${KERNEL}.img"
> OSRELEASE="$(eval chroot ${CHROOTDIR} make -C /usr/src/release \
> TARGET=${EMBEDDED_TARGET} TARGET_ARCH=${EMBEDDED_TARGET_ARCH} \
> -V OSRELEASE)"
> chroot ${CHROOTDIR} mkdir -p ${DESTDIR}
> chroot ${CHROOTDIR} truncate -s ${IMAGE_SIZE} ${IMGBASE##${CHROOTDIR}}
> export mddev=$(chroot ${CHROOTDIR} \
> mdconfig -f ${IMGBASE##${CHROOTDIR}} ${MD_ARGS})
> arm_create_disk
> arm_install_base
> arm_install_uboot
> mdconfig -d -u ${mddev}
> chroot ${CHROOTDIR} rmdir ${DESTDIR}
> mv ${IMGBASE} ${CHROOTDIR}/${OBJDIR}/${OSRELEASE}-${KERNEL}.img
> chroot ${CHROOTDIR} mkdir -p /R
> chroot ${CHROOTDIR} cp -p ${OBJDIR}/${OSRELEASE}-${KERNEL}.img \
> /R/${OSRELEASE}-${KERNEL}.img
> chroot ${CHROOTDIR} xz -T ${XZ_THREADS} /R/${OSRELEASE}-${KERNEL}.img
> cd ${CHROOTDIR}/R && sha256 ${OSRELEASE}* \
> > CHECKSUM.SHA256
> cd ${CHROOTDIR}/R && md5 ${OSRELEASE}* \
> > CHECKSUM.MD5
284,292c358,394
< buildenv_setup
< load_target_env
< eval chroot ${CHROOTDIR} make -C /usr/src ${RELEASE_WMAKEFLAGS} buildworld
< eval chroot ${CHROOTDIR} make -C /usr/src ${RELEASE_KMAKEFLAGS} buildkernel
< eval chroot ${CHROOTDIR} make -C /usr/src/release ${RELEASE_RMAKEFLAGS} \
< release
< eval chroot ${CHROOTDIR} make -C /usr/src/release ${RELEASE_RMAKEFLAGS} \
< install DESTDIR=/R WITH_COMPRESSED_IMAGES=${WITH_COMPRESSED_IMAGES} \
< WITH_COMPRESSED_VMIMAGES=${WITH_COMPRESSED_VMIMAGES}
---
> return 0
> } # chroot_arm_armv6_build_release()
>
> # main(): Start here.
> main() {
> set -e # Everything must succeed
> env_setup
> while getopts c: opt; do
> case ${opt} in
> c)
> RELEASECONF="${OPTARG}"
> ;;
> \?)
> usage
> ;;
> esac
> done
> shift $(($OPTIND - 1))
> if [ ! -z "${RELEASECONF}" ]; then
> if [ -e "${RELEASECONF}" ]; then
> . ${RELEASECONF}
> else
> echo "Nonexistent configuration file: ${RELEASECONF}"
> echo "Using default build environment."
> fi
> fi
> env_check
> trap "umount ${CHROOTDIR}/dev" EXIT # Clean up devfs mount on exit
> chroot_setup
> extra_chroot_setup
> chroot_build_target
> ${chroot_build_release_cmd}
>
> return 0
> } # main()
>
> main "${@}"